


void UART3_Write_CText(const char *txt3)
 {
   while (*txt3)
     {
     UART3_Write(*txt3++);
    // Delay_us(500);
     }
}

void UART3_Write_Text(unsigned char *T)    // at adress  0x002 taille 42 bytes
{
  while(*(T)>0)     // verif sur VBRAY en mode ASCII
   {
    UART3_Write(*(T++));   // c3 variable globale
   }
}

void CRLF3()
{
 UART3_Write(CR);
 UART3_Write(LF);
}


void UART3_Write(unsigned char cc)      // 16MHz 19200 bauds
{
    c3=~cc;    // complement du caractere !
    // avec TX3_PIN => RA2
  _asm{
    RSsend2:
        movlw   8                ; 8 bits
        movwf   _RS_Count        ; compteur de bits envoyes
        bcf     LATA,2            ; bit de start
        call    RSdelai2        ; tempo
       //   rrf        _c1,f        ; on recupere dans C le bit à envoyer
       //  syntaxe a revoir en fonction du PIC utilise  rrcf avec 18F87J50
       //                                                rrf avec PIC12F1840
    L00:
        rrf    _c3,1        ; on recupere dans C le bit a envoyer
        btfsc   STATUS,C        ; bit a envoyer = 1 ?
        goto    L10                ; oui
        bsf     LATA,2          ; sinon 0
        goto    L20                ; on continue sur la tempo
    L10:
        bcf     LATA,2          ; bit a 1
    L20:
        call    RSdelai2                ; tempo
        decfsz  _RS_Count,1        ; on decremente le compteur de bits envoyés
        goto    L00                ; on continue sur les bits suivants
        bsf     LATA,2         ; bit de stop
        call    RSdelai2        ; tempo pour bit de stop
         call    RSdelai2        ; tempo pour bit de stop
        goto    LA1

    RSdelai2:                 // 52 S / bit at 19200 bauds
         MOVLW 28 ;
         MOVWF _RS_tmp ;
    RS00:
         NOP;                ; fait parti de la tempo!
         NOP;
         NOP;
         NOP;
        // NOP;
         DECFSZ _RS_tmp,F ;
         GOTO   RS00 ;
         NOP;
         NOP;
         NOP;
         RETURN ;

    LA1:    nop;
   }
 }